## graphviz 14.1.2

=== cmd/dot/CMakeLists.txt ===
include_directories(
  ../../lib
  ${CMAKE_CURRENT_BINARY_DIR}
  ../../lib/cdt
  ../../lib/cgraph
  ../../lib/common
  ../../lib/gvc
  ../../lib/pathplan
)

if(BUILD_SHARED_LIBS)
  add_executable(dot
    # Source files
    dot.c
    no_builtins.c
  )

  target_compile_definitions(dot PRIVATE DEMAND_LOADING=1)

  target_link_libraries(dot PRIVATE
    cgraph
    gvc
  )

  if(APPLE)
    set_target_properties(dot PROPERTIES LINK_FLAGS -Wl,-stack_size,0x2000000)
  elseif(MINGW)
    set_target_properties(dot PROPERTIES LINK_FLAGS -Wl,--stack,0x2000000)
  elseif(WIN32)
    set(STACK_SIZE 0x2000000)
    if(DEFINED ENV{CFLAGS})
      if("$ENV{CFLAGS}" MATCHES "-fsanitize=[^ ]*address")
        # The `test_long_chain` test case requires `dot` to be linked with a
        # larger than normal stack when using ASan
        set(STACK_SIZE 0x4000000)
      endif()
    endif()
    set_target_properties(dot PROPERTIES LINK_FLAGS /STACK:${STACK_SIZE})
  endif()

  # Installation location of executables
  install(
    TARGETS dot
    RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
    LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
  )

  add_executable(dot_builtins
    dot.c
    dot_builtins.cpp
  )

  target_compile_definitions(dot_builtins PRIVATE DEMAND_LOADING=1)

  target_link_libraries(dot_builtins PRIVATE
    cdt
    cgraph
    gvc
    gvplugin_core
    gvplugin_dot_layout
    gvplugin_neato_layout
    gvplugin_vt
    pathplan
    xdot
  )

  if(PANGOCAIRO_FOUND)
    target_link_libraries(dot_builtins PRIVATE gvplugin_kitty)
  endif()

  if(WIN32)
    target_link_libraries(dot_builtins PRIVATE gvplugin_gdiplus)
  endif()

  if(APPLE)
    set_target_properties(dot_builtins PROPERTIES
      LINK_FLAGS -Wl,-stack_size,0x2000000)
  elseif(MINGW)
    set_target_properties(dot_builtins PROPERTIES
      LINK_FLAGS -Wl,--stack,0x2000000)
  elseif(WIN32)
    set_target_properties(dot_builtins PROPERTIES LINK_FLAGS /STACK:0x2000000)
  endif()

  if(EXPAT_FOUND)
    target_include_directories(dot_builtins SYSTEM PRIVATE
      ${EXPAT_INCLUDE_DIRS}
    )
    target_link_libraries(dot_builtins PRIVATE ${EXPAT_LIBRARIES})
  endif()

  if(GD_FOUND)
    target_link_libraries(dot_builtins PRIVATE gvplugin_gd)
  endif()

  if(GTS_FOUND)
    target_include_directories(dot_builtins SYSTEM PRIVATE
      ${GTS_INCLUDE_DIRS}
    )
    target_link_libraries(dot_builtins PRIVATE ${GTS_LINK_LIBRARIES})
  endif()

  if(Freetype_FOUND AND LASI_FOUND AND PANGOCAIRO_FOUND)
    target_link_libraries(dot_builtins PRIVATE gvplugin_lasi)
  endif()

  if(PANGOCAIRO_FOUND)
    target_link_libraries(dot_builtins PRIVATE gvplugin_pango)
    if(WEBP_FOUND)
      target_link_libraries(dot_builtins PRIVATE gvplugin_webp)
    endif()
  endif()

  if(HAVE_QUARTZ)
    target_link_libraries(dot_builtins PRIVATE gvplugin_quartz)
  endif()

  install(
    TARGETS dot_builtins
    RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
    LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
  )
else()
  add_executable(dot
    dot.c
    dot_builtins.cpp
  )

  target_compile_definitions(dot PRIVATE DEMAND_LOADING=0)

  target_link_libraries(dot PRIVATE
    cdt
    cgraph
    gvc
    gvplugin_core
    gvplugin_dot_layout
    gvplugin_neato_layout
    gvplugin_vt
    pathplan
    xdot
  )

  if(PANGOCAIRO_FOUND)
    target_link_libraries(dot PRIVATE gvplugin_kitty)
  endif()

  if(WIN32)
    target_link_libraries(dot PRIVATE gvplugin_gdiplus)
  endif()

  if(APPLE)
    set_target_properties(dot PROPERTIES LINK_FLAGS -Wl,-stack_size,0x2000000)
  elseif(MINGW)
    set_target_properties(dot PROPERTIES LINK_FLAGS -Wl,--stack,0x2000000)
  elseif(WIN32)
    set_target_properties(dot PROPERTIES LINK_FLAGS /STACK:0x2000000)
  endif()

  if(GD_FOUND)
    target_link_libraries(dot PRIVATE gvplugin_gd)
  endif()

  if(Freetype_FOUND AND LASI_FOUND AND PANGOCAIRO_FOUND)
    target_link_libraries(dot PRIVATE gvplugin_lasi)
  endif()

  if(CAIRO_FOUND AND PANGOCAIRO_FOUND)
    target_link_libraries(dot PRIVATE gvplugin_pango)
  endif()

  if(WEBP_FOUND)
    target_link_libraries(dot PRIVATE gvplugin_webp)
  endif()

  if(HAVE_QUARTZ)
    target_link_libraries(dot PRIVATE gvplugin_quartz)
  endif()

  install(
    TARGETS dot
    RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
    LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
  )
endif()

# Aliases to the dot executable (not including '.exe' suffix)
list(APPEND dot_aliases circo fdp neato osage patchwork twopi)
if(with_sfdp)
  list(APPEND dot_aliases sfdp)
endif()

# We use copying instead of symlinking for Cygwin to avoid
# https://gitlab.com/graphviz/graphviz/-/issues/2123

foreach(cmd_alias IN LISTS dot_aliases)
  set(DOTCOPY
      "${CMAKE_CURRENT_BINARY_DIR}/${cmd_alias}${CMAKE_EXECUTABLE_SUFFIX}")
  if(WIN32 OR CYGWIN)
    # Copy dot executable to each alias name then install copies to bindir
    add_custom_command(
      TARGET dot
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:dot> ${DOTCOPY}
      COMMENT "Copying dot to ${DOTCOPY}"
    )
    install(
      PROGRAMS ${DOTCOPY}
      DESTINATION ${BINARY_INSTALL_DIR}
    )
  else()
    # For not-WIN32, install symlinks from dot_aliases -> dot_executable in
    # bindir. Note: This may be brittle. This builds a symlink from
    # ./cmd_alias -> ./dot in ${CMAKE_CURRENT_BINARY_DIR}, then installs that
    # symlink into ${BINARY_INSTALL_DIR}. This presumes
    # ${CMAKE_CURRENT_BINARY_DIR}/dot is installed to ${BINARY_INSTALL_DIR}/dot.
    # There is a (small?) risk of dangling symlinks
    add_custom_command(
      TARGET dot
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E create_symlink $<TARGET_FILE_NAME:dot>
        ${cmd_alias}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Linking dot as ${cmd_alias}"
    )
    install(
      FILES ${DOTCOPY}
      DESTINATION ${BINARY_INSTALL_DIR}
    )
  endif()
endforeach()

install(
  FILES dot_sandbox
  DESTINATION ${BINARY_INSTALL_DIR}
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
    WORLD_READ WORLD_EXECUTE
)

# Specify man pages to be installed
if(GZIP)
  add_custom_target(man-dot ALL DEPENDS dot.1.gz
                    COMMENT "dot man page")
  add_custom_command(
    OUTPUT dot.1.gz
    COMMAND ${GZIP} -9 --no-name --to-stdout dot.1
      >"${CMAKE_CURRENT_BINARY_DIR}/dot.1.gz"
    MAIN_DEPENDENCY dot.1
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "compress dot man page")
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/dot.1.gz
    DESTINATION ${MAN_INSTALL_DIR}/man1)
  add_custom_target(man-dot_sandbox ALL DEPENDS dot_sandbox.1.gz
                    COMMENT "dot_sandbox man page")
  add_custom_command(
    OUTPUT dot_sandbox.1.gz
    COMMAND ${GZIP} -9 --no-name --to-stdout dot_sandbox.1
      >"${CMAKE_CURRENT_BINARY_DIR}/dot_sandbox.1.gz"
    MAIN_DEPENDENCY dot_sandbox.1
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "compress dot_sandbox man page")
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/dot_sandbox.1.gz
    DESTINATION ${MAN_INSTALL_DIR}/man1)
  add_custom_target(man-osage ALL DEPENDS osage.1.gz
                    COMMENT "osage man page")
  add_custom_command(
    OUTPUT osage.1.gz
    COMMAND ${GZIP} -9 --no-name --to-stdout osage.1
      >"${CMAKE_CURRENT_BINARY_DIR}/osage.1.gz"
    MAIN_DEPENDENCY osage.1
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "compress osage man page")
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/osage.1.gz
    DESTINATION ${MAN_INSTALL_DIR}/man1)
  add_custom_target(man-patchwork ALL DEPENDS patchwork.1.gz
                    COMMENT "patchwork man page")
  add_custom_command(
    OUTPUT patchwork.1.gz
    COMMAND ${GZIP} -9 --no-name --to-stdout patchwork.1
      >"${CMAKE_CURRENT_BINARY_DIR}/patchwork.1.gz"
    MAIN_DEPENDENCY patchwork.1
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "compress patchwork man page")
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/patchwork.1.gz
    DESTINATION ${MAN_INSTALL_DIR}/man1)
else()
  install(
    FILES dot.1 dot_sandbox.1 osage.1 patchwork.1
    DESTINATION ${MAN_INSTALL_DIR}/man1
  )
endif()

# front ends whose man page is just a symlink to dot’s man page
list(APPEND linkedman circo fdp neato twopi)
if(with_sfdp)
  list(APPEND linkedman sfdp)
endif()

foreach(alias IN LISTS linkedman)
  if(WIN32 OR CYGWIN)
    if(GZIP)
      add_custom_target(man-${alias} ALL
        DEPENDS ${alias}.1.gz
        COMMENT "${alias} man page"
      )
      add_custom_command(
        OUTPUT ${alias}.1.gz
        COMMAND ${CMAKE_COMMAND} -E copy dot.1.gz ${alias}.1.gz
        MAIN_DEPENDENCY dot.1.gz
        COMMENT "Copying dot.1.gz to ${alias}.1.gz"
      )
      install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${alias}.1.gz
        DESTINATION ${MAN_INSTALL_DIR}/man1
      )
    else()
      install(
        FILES dot.1
        DESTINATION ${MAN_INSTALL_DIR}/man1
        RENAME ${alias}.1
      )
    endif()
  else()
    if(GZIP)
      add_custom_target(man-${alias} ALL
        DEPENDS ${alias}.1.gz
        COMMENT "${alias} man page"
      )
      add_custom_command(
        OUTPUT ${alias}.1.gz
        COMMAND ${CMAKE_COMMAND} -E create_symlink dot.1.gz ${alias}.1.gz
        COMMENT "Linking dot.1.gz as ${alias}.1.gz"
      )
      install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${alias}.1.gz
        DESTINATION ${MAN_INSTALL_DIR}/man1
      )
    else()
      add_custom_target(man-${alias} ALL
        DEPENDS ${alias}.1
        COMMENT "${alias} man page"
      )
      add_custom_command(
        OUTPUT ${alias}.1
        COMMAND ${CMAKE_COMMAND} -E create_symlink dot.1 ${alias}.1
        COMMENT "Linking dot.1 as ${alias}.1"
      )
      install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${alias}.1
        DESTINATION ${MAN_INSTALL_DIR}/man1
      )
    endif()
  endif()
endforeach()

if(NOT CMAKE_CROSSCOMPILING)
  configure_file(
    ../../cmake/configure_plugins.cmake.in configure_plugins.cmake @ONLY)

  install(SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/configure_plugins.cmake)
endif()

=== lib/cgraph/CMakeLists.txt ===
BISON_TARGET(Grammar ${CMAKE_CURRENT_SOURCE_DIR}/grammar.y
                     ${CMAKE_CURRENT_BINARY_DIR}/grammar.c)
FLEX_TARGET(Scan
  ${CMAKE_CURRENT_SOURCE_DIR}/scan.l
  ${CMAKE_CURRENT_BINARY_DIR}/scan.c
  COMPILE_FLAGS --case-insensitive
)
ADD_FLEX_BISON_DEPENDENCY(Scan Grammar)

add_definitions(-DEXPORT_CGRAPH -DEXPORT_CGHDR)
if(WIN32 AND NOT MINGW)
  add_definitions(-DYY_NO_UNISTD_H)
endif()

add_library(cgraph
  # Header files
  cghdr.h
  cgraph.h
  ingraphs.h
  node_set.h
  rdr.h

  # Source files
  acyclic.c
  agerror.c
  apply.c
  attr.c
  edge.c
  graph.c
  id.c
  imap.c
  ingraphs.c
  io.c
  node.c
  node_induce.c
  obj.c
  rec.c
  refstr.c
  subg.c
  tred.c
  unflatten.c
  utils.c
  write.c

  # Generated files
  ${BISON_Grammar_OUTPUTS}
  ${FLEX_Scan_OUTPUTS}
)

if(HAVE_C_WUNUSED_BUT_SET_VARIABLE)
  set_source_files_properties(${BISON_Grammar_OUTPUTS}
    PROPERTIES COMPILE_FLAGS -Wno-unused-but-set-variable)
endif()

target_include_directories(cgraph
  PUBLIC
    $<INSTALL_INTERFACE:include>
    $<INSTALL_INTERFACE:include/graphviz>
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../cdt>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
)

target_link_libraries(cgraph PRIVATE util)
target_link_libraries(cgraph PUBLIC cdt)

# Installation location of library files
install(
  TARGETS cgraph
  EXPORT graphvizTargets
  RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
  LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
)

# Specify headers to be installed
install(
  FILES cgraph.h
  DESTINATION ${HEADER_INSTALL_DIR}
)

# Specify man pages to be installed
if(GZIP)
  add_custom_target(man-cgraph ALL DEPENDS cgraph.3.gz
                    COMMENT "cgraph man page")
  add_custom_command(
    OUTPUT cgraph.3.gz
    COMMAND ${GZIP} -9 --no-name --to-stdout cgraph.3
      >"${CMAKE_CURRENT_BINARY_DIR}/cgraph.3.gz"
    MAIN_DEPENDENCY cgraph.3
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "compress cgraph man page")
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/cgraph.3.gz
    DESTINATION ${MAN_INSTALL_DIR}/man3)
else()
  install(
    FILES cgraph.3
    DESTINATION ${MAN_INSTALL_DIR}/man3
  )
endif()

# Specify library version and soversion
set_target_properties(cgraph PROPERTIES
  VERSION 8.0.5
  SOVERSION 8
)

=== lib/edgepaint/CMakeLists.txt ===
add_library(edgepaintlib STATIC
  edge_distinct_coloring.h
  furtherest_point.h
  intersection.h
  lab.h
  lab_gamut.h
  node_distinct_coloring.h

  edge_distinct_coloring.c
  furtherest_point.c
  intersection.c
  lab.c
  lab_gamut.c
  node_distinct_coloring.c
)

target_include_directories(edgepaintlib PRIVATE
  ..
  ../cdt
  ../cgraph
  ../common
  ../gvc
  ../pathplan
)

target_link_libraries(edgepaintlib PRIVATE util)

# work around needed for an object library
# https://gitlab.com/graphviz/graphviz/-/issues/1613
if(APPLE)
  target_compile_options(edgepaintlib PRIVATE "-fno-common")
endif()

=== lib/gvc/CMakeLists.txt ===
add_definitions(-DGVC_EXPORTS -DGVLIBDIR="${LIBRARY_INSTALL_DIR}/graphviz")

add_library(gvc
  # Header files
  gvc.h
  gvcext.h
  gvcint.h
  gvcjob.h
  gvconfig.h
  gvcommon.h
  gvcproc.h
  gvio.h
  gvplugin.h
  gvplugin_device.h
  gvplugin_layout.h
  gvplugin_loadimage.h
  gvplugin_render.h
  gvplugin_textlayout.h

  # Source files
  gvc.c
  gvconfig.c
  gvcontext.c
  gvdevice.c
  gvevent.c
  gvjobs.c
  gvlayout.c
  gvloadimage.c
  gvplugin.c
  gvrender.c
  gvtextlayout.c
  gvtool_tred.c
  gvusershape.c
)

target_include_directories(gvc
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../cdt>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../cgraph>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../common>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../pathplan>
    $<INSTALL_INTERFACE:include>
    $<INSTALL_INTERFACE:include/graphviz>
  PRIVATE
    ../..
)

if(WIN32 AND NOT MINGW)
  target_include_directories(gvc PRIVATE
    ../../windows/include/unistd
  )
endif()

target_link_libraries(gvc PRIVATE
  $<TARGET_OBJECTS:common_obj>
  $<TARGET_OBJECTS:pack_obj>
)

target_link_libraries(gvc PRIVATE
  cdt
  cgraph
  common
  pack
  util
)

if(LTDL_FOUND)
  target_include_directories(gvc SYSTEM PRIVATE ${LTDL_INCLUDE_DIRS})
  if(NOT WIN32 OR MINGW)
    target_link_libraries(gvc PUBLIC ${LTDL_LIBRARIES})
  endif()
endif()

if(ZLIB_FOUND)
  target_include_directories(gvc SYSTEM PRIVATE ${ZLIB_INCLUDE_DIRS})
  target_link_libraries(gvc PUBLIC ${ZLIB_LIBRARIES})
endif()

if(with_ortho)
  target_link_libraries(gvc PRIVATE
    $<TARGET_OBJECTS:ortho_obj>
  )
  target_link_libraries(gvc PRIVATE ortho)
endif()

# Installation location of library files
install(
  TARGETS gvc
  EXPORT graphvizTargets
  RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
  LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
)

# Specify headers to be installed
install(
  FILES
    gvc.h
    gvcext.h
    gvcjob.h
    gvconfig.h
    gvcommon.h
    gvplugin.h
    gvplugin_device.h
    gvplugin_layout.h
    gvplugin_loadimage.h
    gvplugin_render.h
    gvplugin_textlayout.h
  DESTINATION ${HEADER_INSTALL_DIR}
)

# Specify man pages to be installed
if(GZIP)
  add_custom_target(man-gvc ALL DEPENDS gvc.3.gz
                    COMMENT "gvc man page")
  add_custom_command(
    OUTPUT gvc.3.gz
    COMMAND ${GZIP} -9 --no-name --to-stdout gvc.3
      >"${CMAKE_CURRENT_BINARY_DIR}/gvc.3.gz"
    MAIN_DEPENDENCY gvc.3
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "compress gvc man page")
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/gvc.3.gz
    DESTINATION ${MAN_INSTALL_DIR}/man3)
else()
  install(
    FILES gvc.3
    DESTINATION ${MAN_INSTALL_DIR}/man3
  )
endif()

# Specify library version and soversion
set_target_properties(gvc PROPERTIES
  VERSION 7.0.6
  SOVERSION 7
)

# Include DLLs with this library on Windows
if(WIN32 AND EXPAT_FOUND AND install_win_dependency_dlls)
  install(
    FILES
      ${EXPAT_RUNTIME_LIBRARIES}
    DESTINATION ${BINARY_INSTALL_DIR}
  )
endif()

if(WIN32 AND ZLIB_FOUND AND install_win_dependency_dlls)
  find_program(ZLIB_RUNTIME_LIBRARY NAMES zlib1.dll)
  install(
    FILES
      ${ZLIB_RUNTIME_LIBRARY}
    DESTINATION ${BINARY_INSTALL_DIR}
  )
endif()

=== lib/gvpr/CMakeLists.txt ===
add_definitions(-DEXPORT_GVPR)

add_library(gvpr
  # Header files
  actions.h
  compile.h
  gdefs.h
  gprdata.inc
  gprstate.h
  gvpr.h
  parse.h
  trieFA.h

  # Source files
  actions.c
  compile.c
  gvpr.c
  gprstate.c
  parse.c
)

target_include_directories(gvpr
  PUBLIC
    $<INSTALL_INTERFACE:include>
    $<INSTALL_INTERFACE:include/graphviz>
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/..>
      # needed to find generated expr/exparse.h
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/../common>
      # needed to find generated common/colortbl.h
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../cdt>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../cgraph>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../common>
)

if(GETOPT_FOUND)
  target_include_directories(gvpr SYSTEM PRIVATE
    ${GETOPT_INCLUDE_DIRS}
  )
endif()

if(WIN32 AND NOT MINGW)
  target_include_directories(gvpr PRIVATE ../../windows/include/unistd)
endif()

target_link_libraries(gvpr PRIVATE
  $<TARGET_OBJECTS:ast>
  cgraph
  gvc
  util
  $<TARGET_OBJECTS:expr>
  $<TARGET_OBJECTS:sfio>
)

if(NOT HAVE_GETOPT_H)
  target_link_libraries(gvpr PRIVATE ${GETOPT_LINK_LIBRARIES})
endif()

# Installation location of library files
install(
  TARGETS gvpr
  EXPORT graphvizTargets
  RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
  LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
)

# Specify headers to be installed
install(
  FILES gvpr.h
  DESTINATION ${HEADER_INSTALL_DIR}
)

# Specify man pages to be installed
if(GZIP)
  add_custom_target(man-gvprlib ALL DEPENDS gvpr.3.gz
                    COMMENT "gvpr library man page")
  add_custom_command(
    OUTPUT gvpr.3.gz
    COMMAND ${GZIP} -9 --no-name --to-stdout gvpr.3
      >"${CMAKE_CURRENT_BINARY_DIR}/gvpr.3.gz"
    MAIN_DEPENDENCY gvpr.3
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "compress gvpr library man page")
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/gvpr.3.gz
    DESTINATION ${MAN_INSTALL_DIR}/man3)
else()
  install(
    FILES gvpr.3
    DESTINATION ${MAN_INSTALL_DIR}/man3
  )
endif()

# Specify library version and soversion
set_target_properties(gvpr PROPERTIES
  VERSION 2.0.7
  SOVERSION 2
)

=== lib/pathplan/CMakeLists.txt ===
add_definitions(-DPATHPLAN_EXPORTS)

add_library(pathplan
  # Header files
  pathgeom.h
  pathplan.h
  pathutil.h
  solvers.h
  tri.h
  vis.h
  vispath.h

  # Source files
  cvt.c
  inpoly.c
  route.c
  shortest.c
  shortestpth.c
  solvers.c
  triang.c
  util.c
  visibility.c
)

target_include_directories(pathplan
  PUBLIC
    $<INSTALL_INTERFACE:include>
    $<INSTALL_INTERFACE:include/graphviz>
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
)

target_link_libraries(pathplan PRIVATE util)

# Installation location of library files
install(
  TARGETS pathplan
  EXPORT graphvizTargets
  RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
  LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
)

# Specify headers to be installed
install(
  FILES pathgeom.h pathplan.h
  DESTINATION ${HEADER_INSTALL_DIR}
)

# Specify man pages to be installed
if(GZIP)
  add_custom_target(man-pathplan ALL DEPENDS pathplan.3.gz
                    COMMENT "pathplan man page")
  add_custom_command(
    OUTPUT pathplan.3.gz
    COMMAND ${GZIP} -9 --no-name --to-stdout pathplan.3
      >"${CMAKE_CURRENT_BINARY_DIR}/pathplan.3.gz"
    MAIN_DEPENDENCY pathplan.3
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "compress pathplan man page")
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/pathplan.3.gz
    DESTINATION ${MAN_INSTALL_DIR}/man3)
else()
  install(
    FILES pathplan.3
    DESTINATION ${MAN_INSTALL_DIR}/man3
  )
endif()

# Specify library version and soversion
set_target_properties(pathplan PROPERTIES
  VERSION 4.0.4
  SOVERSION 4
)

=== lib/xdot/CMakeLists.txt ===
add_definitions(-DEXPORT_XDOT)

add_library(xdot
  # Header files
  xdot.h

  # Source files
  xdot.c
)

target_include_directories(xdot
  PUBLIC
    $<INSTALL_INTERFACE:include>
    $<INSTALL_INTERFACE:include/graphviz>
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
)

# Installation location of library files
install(
  TARGETS xdot
  EXPORT graphvizTargets
  RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
  LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
)

# Specify headers to be installed
install(
  FILES xdot.h
  DESTINATION ${HEADER_INSTALL_DIR}
)

# Specify man pages to be installed
if(GZIP)
  add_custom_target(man-xdot ALL DEPENDS xdot.3.gz
                    COMMENT "xdot man page")
  add_custom_command(
    OUTPUT xdot.3.gz
    COMMAND ${GZIP} -9 --no-name --to-stdout xdot.3
      >"${CMAKE_CURRENT_BINARY_DIR}/xdot.3.gz"
    MAIN_DEPENDENCY xdot.3
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "compress xdot man page")
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/xdot.3.gz
    DESTINATION ${MAN_INSTALL_DIR}/man3)
else()
  install(
    FILES xdot.3
    DESTINATION ${MAN_INSTALL_DIR}/man3
  )
endif()

# Specify library version and soversion
set_target_properties(xdot PROPERTIES
  VERSION 4.0.0
  SOVERSION 4
)

=== tclpkg/gv/CMakeLists.txt ===
if(ENABLE_SWIG)
  set(UseSWIG_MODULE_VERSION 2) # cmake-lint: disable=C0103
  include(UseSWIG)

  set_property(SOURCE gv.i PROPERTY CPLUSPLUS ON)

  if(ENABLE_SHARP)
    swig_add_library(gv_sharp
      LANGUAGE csharp
      SOURCES gv.cpp gv.i gv_builtins.c gv_dummy_init.c
    )
    target_compile_definitions(gv_sharp PRIVATE DEMAND_LOADING=1)
    set_property(TARGET gv_sharp PROPERTY SWIG_COMPILE_OPTIONS -namespace)
    target_link_libraries(gv_sharp PRIVATE cdt cgraph gvc)

    get_property(gv_sharp_support
      TARGET gv_sharp
      PROPERTY SWIG_SUPPORT_FILES_DIRECTORY
    )
    install(
      TARGETS gv_sharp
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/sharp
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
    install(
      DIRECTORY ${gv_sharp_support}/
      DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/sharp
    )
  endif()

  if(ENABLE_D)
    swig_add_library(gv_d
      LANGUAGE d
      SOURCES gv.cpp gv.i gv_builtins.c gv_dummy_init.c
    )
    target_compile_definitions(gv_d PRIVATE DEMAND_LOADING=1)
    target_link_libraries(gv_d PRIVATE cdt cgraph gvc)

    install(
      TARGETS gv_d
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/d
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
  endif()

  if(ENABLE_GO)
    swig_add_library(gv_go
      LANGUAGE go
      SOURCES gv.cpp gv.i gv_builtins.c gv_dummy_init.c
    )
    target_compile_definitions(gv_go PRIVATE DEMAND_LOADING=1)
    set_property(
      TARGET gv_go PROPERTY SWIG_COMPILE_OPTIONS -intgosize ${INTGOSIZE}
    )
    if(HAVE_CXX_WUNUSED_FUNCTION)
      set_property(
        TARGET gv_go
        PROPERTY SWIG_GENERATED_COMPILE_OPTIONS -Wno-unused-function
      )
    endif()
    target_link_libraries(gv_go PRIVATE cdt cgraph gvc)

    add_custom_target(gv.go
      COMMAND echo "package gv" >gv.go
      BYPRODUCTS gv.go
      COMMENT "generating gv.go"
    )
    add_dependencies(gv_go gv.go)

    add_custom_target(runtime.h
      COMMAND ${SWIG_EXECUTABLE} -c++ -go -intgosize ${INTGOSIZE}
        -external-runtime runtime.h
      BYPRODUCTS runtime.h
      COMMENT "generating runtime.h"
    )
    add_dependencies(gv_go runtime.h)

    install(
      TARGETS gv_go
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/go
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/gv.go
            ${CMAKE_CURRENT_BINARY_DIR}/runtime.h
      DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/go
    )
  endif()

  if(ENABLE_GUILE)
    swig_add_library(gv_guile
      LANGUAGE guile
      SOURCES gv.cpp gv.i gv_builtins.c gv_dummy_init.c
    )
    target_compile_definitions(gv_guile PRIVATE DEMAND_LOADING=1)
    set_property(
      TARGET gv_guile
      PROPERTY SWIG_GENERATED_INCLUDE_DIRECTORIES ${GUILE_INCLUDE_DIRS}
    )
    if(HAVE_CXX_WUNUSED_PARAMETER)
      set_property(
        TARGET gv_guile
        PROPERTY SWIG_GENERATED_COMPILE_OPTIONS -Wno-unused-parameter
      )
    endif()
    target_link_libraries(
      gv_guile PRIVATE cdt cgraph gvc ${GUILE_LINK_LIBRARIES}
    )

    install(
      TARGETS gv_guile
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/guile
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
  endif()

  if(ENABLE_JAVA)
    swig_add_library(gv_java
      LANGUAGE java
      SOURCES gv.cpp gv.i gv_builtins.c gv_java_init.c
    )
    target_compile_definitions(gv_java PRIVATE DEMAND_LOADING=1)
    set_property(
      TARGET gv_java
      PROPERTY SWIG_COMPILE_OPTIONS -package org.graphviz
    )
    set_property(
      TARGET gv_java
      PROPERTY SWIG_GENERATED_INCLUDE_DIRECTORIES
        ${JNI_INCLUDE_DIRS}
    )
    target_link_libraries(gv_java PRIVATE cdt cgraph gvc ${JNI_LIBRARIES})

    install(
      TARGETS gv_java
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/java
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
  endif()

  if(ENABLE_JAVASCRIPT)
    swig_add_library(gv_javascript
      LANGUAGE javascript
      SOURCES gv.cpp gv.i gv_builtins.c gv_dummy_init.c
    )
    target_compile_definitions(gv_javascript PRIVATE DEMAND_LOADING=1)
    set_property(TARGET gv_javascript PROPERTY SWIG_COMPILE_OPTIONS -jsc)
    set_property(
      TARGET gv_javascript
      PROPERTY SWIG_GENERATED_INCLUDE_DIRECTORIES
        ${JAVASCRIPTCORE_INCLUDE_DIRS}
    )
    set(JS_FLAGS "")
    if(HAVE_CXX_WSHADOW)
      list(APPEND JS_FLAGS -Wno-shadow)
    endif()
    if(HAVE_CXX_WSIGN_COMPARE)
      list(APPEND JS_FLAGS -Wno-sign-compare)
    endif()
    if(HAVE_CXX_WUNUSED_PARAMETER)
      list(APPEND JS_FLAGS -Wno-unused-parameter)
    endif()
    set_property(
      TARGET gv_javascript
      PROPERTY SWIG_GENERATED_COMPILE_OPTIONS "${JS_FLAGS}"
    )
    target_link_libraries(gv_javascript
      PRIVATE cdt cgraph gvc ${JAVASCRIPTCORE_LIBRARIES}
    )

    install(
      TARGETS gv_javascript
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/javascript
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
  endif()

  if(ENABLE_LUA)
    swig_add_library(gv_lua
      LANGUAGE lua
      SOURCES gv.cpp gv.i gv_builtins.c gv_dummy_init.c
    )
    target_compile_definitions(gv_lua PRIVATE DEMAND_LOADING=1)
    set_property(
      TARGET gv_lua
      PROPERTY SWIG_GENERATED_INCLUDE_DIRECTORIES ${LUA_INCLUDE_DIR}
    )
    target_link_libraries(gv_lua PRIVATE cdt cgraph gvc ${LUA_LIBRARIES})

    install(
      TARGETS gv_lua
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/lua
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
  endif()

  if(ENABLE_PERL)
    swig_add_library(gv_perl
      LANGUAGE perl5
      SOURCES gv.cpp gv.i gv_builtins.c gv_dummy_init.c
    )
    target_compile_definitions(gv_perl PRIVATE DEMAND_LOADING=1)
    set_property(
      TARGET gv_perl
      PROPERTY SWIG_GENERATED_INCLUDE_DIRECTORIES ${PERL_INCLUDE_PATH}
    )
    if(HAVE_CXX_WUNUSED_PARAMETER)
      set_property(
        TARGET gv_perl
        PROPERTY SWIG_GENERATED_COMPILE_OPTIONS -Wno-unused-parameter
      )
    endif()
    target_link_libraries(gv_perl PRIVATE cdt cgraph gvc ${PERL_LIBRARY})

    install(
      TARGETS gv_perl
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/perl
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
  endif()

  if(ENABLE_PHP)
    swig_add_library(gv_php
      LANGUAGE php7
      SOURCES gv.cpp gv.i gv_builtins.c gv_php_init.c
    )
    target_compile_definitions(gv_php PRIVATE DEMAND_LOADING=1)
    set_property(
      TARGET gv_php
      PROPERTY SWIG_GENERATED_INCLUDE_DIRECTORIES ${PHP_INCLUDE_DIRS}
    )
    set_property(
      TARGET gv_php
      APPEND
      PROPERTY INCLUDE_DIRECTORIES ${PHP_INCLUDE_DIRS}
    )
    set(PHP_FLAGS "")
    if(HAVE_CXX_WUNUSED_FUNCTION)
      list(APPEND PHP_FLAGS -Wno-unused-function)
    endif()
    if(HAVE_CXX_WUNUSED_LABEL)
      list(APPEND PHP_FLAGS -Wno-unused-label)
    endif()
    if(HAVE_CXX_WUNUSED_PARAMETER)
      list(APPEND PHP_FLAGS -Wno-unused-parameter)
    endif()
    if(HAVE_CXX_WUNUSED_VARIABLE)
      list(APPEND PHP_FLAGS -Wno-unused-variable)
    endif()
    set_property(
      TARGET gv_php
      PROPERTY SWIG_GENERATED_COMPILE_OPTIONS "${PHP_FLAGS}"
    )
    target_link_libraries(gv_php PRIVATE cdt cgraph gvc ${PHP_LIBRARIES})

    install(
      TARGETS gv_php
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/php
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
  endif()

  if(ENABLE_PYTHON)
    swig_add_library(gv_python3
      LANGUAGE python
      SOURCES gv.cpp gv.i gv_builtins.c gv_dummy_init.c
    )
    target_compile_definitions(gv_python3 PRIVATE DEMAND_LOADING=1)
    set_property(
      TARGET gv_python3
      PROPERTY SWIG_GENERATED_INCLUDE_DIRECTORIES ${Python3_INCLUDE_DIRS}
    )
    set(PYTHON_FLAGS "")
    if(HAVE_CXX_WMISSING_FIELD_INITIALIZERS)
      list(APPEND PYTHON_FLAGS -Wno-missing-field-initializers)
    endif()
    if(HAVE_CXX_WSHADOW)
      list(APPEND PYTHON_FLAGS -Wno-shadow)
    endif()
    set_property(
      TARGET gv_python3
      PROPERTY SWIG_GENERATED_COMPILE_OPTIONS "${PYTHON_FLAGS}"
    )
    target_link_libraries(gv_python3
      PRIVATE cdt cgraph gvc ${Python3_LIBRARIES}
    )

    install(
      TARGETS gv_python3
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/python3
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
  endif()

  if(ENABLE_R)
    swig_add_library(gv_R
      LANGUAGE r
      SOURCES gv.cpp gv.i gv_builtins.c gv_dummy_init.c
    )
    target_compile_definitions(gv_R PRIVATE DEMAND_LOADING=1)
    set_property(
      TARGET gv_R
      PROPERTY SWIG_GENERATED_INCLUDE_DIRECTORIES ${R_INCLUDE_DIRS}
    )
    target_link_libraries(gv_R PRIVATE cdt cgraph gvc ${R_LIBRARIES})

    install(
      TARGETS gv_R
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/R
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
  endif()

  if(ENABLE_RUBY)
    swig_add_library(gv_ruby
      LANGUAGE ruby
      SOURCES gv.cpp gv.i gv_builtins.c gv_dummy_init.c
    )
    target_compile_definitions(gv_ruby PRIVATE DEMAND_LOADING=1)
    set_property(
      TARGET gv_ruby
      PROPERTY SWIG_GENERATED_INCLUDE_DIRECTORIES ${Ruby_INCLUDE_DIRS}
    )
    set(RUBY_FLAGS "")
    if(HAVE_CXX_WUNUSED_PARAMETER)
      list(APPEND RUBY_FLAGS -Wno-unused-parameter)
    endif()
    if(HAVE_CXX_WSHADOW)
      list(APPEND RUBY_FLAGS -Wno-shadow)
    endif()
    set_property(
      TARGET gv_ruby
      PROPERTY SWIG_GENERATED_COMPILE_OPTIONS "${RUBY_FLAGS}"
    )
    target_link_libraries(gv_ruby PRIVATE cdt cgraph gvc ${Ruby_LIBRARIES})

    install(
      TARGETS gv_ruby
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/ruby
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )
  endif()

  if(ENABLE_TCL)
    swig_add_library(gv_tcl
      LANGUAGE tcl
      SOURCES gv.cpp gv.i gv_builtins.c gv_tcl_init.c
    )
    target_compile_definitions(gv_tcl PRIVATE DEMAND_LOADING=1)
    set_property(TARGET gv_tcl PROPERTY SWIG_COMPILE_OPTIONS -namespace)
    target_include_directories(gv_tcl PRIVATE SYSTEM ${TCL_INCLUDE_PATH})
    if(HAVE_CXX_WSHADOW)
      set_property(
        TARGET gv_tcl
        PROPERTY SWIG_GENERATED_COMPILE_OPTIONS -Wno-shadow
      )
    endif()
    target_link_libraries(gv_tcl PRIVATE cdt cgraph gvc tclstubs ${TCL_LIBRARY})

    install(
      TARGETS gv_tcl
      RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
      LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}/graphviz/tcl
      ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
    )

    add_custom_target(gv_tcl_pkgindex
      COMMAND
        ${Python3_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/../mkpkgindex.py"
        --file libgv_tcl${CMAKE_SHARED_LIBRARY_SUFFIX}
        --name gv
        --version 0
      DEPENDS ../mkpkgindex.py
      BYPRODUCTS pkgIndex.tcl
      COMMENT "create gv_tcl package index"
    )
    add_dependencies(gv_tcl_pkgindex gv_tcl)
  endif()

  add_custom_target(man-bindings ALL
    DEPENDS gv.3go gv.3guile gv.3java gv.3lua gv.3perl gv.3php gv.3python
      gv.3r gv.3ruby gv.3sharp gv.3tcl
    COMMENT "man pages for language bindings"
  )
  add_custom_command(
    OUTPUT gv.3go gv.3guile gv.3java gv.3lua gv.3perl gv.3php gv.3python gv.3r
      gv.3ruby gv.3sharp gv.3tcl
    COMMAND ${Python3_EXECUTABLE}
      "${CMAKE_CURRENT_SOURCE_DIR}/gv_doc_writer.py"
    MAIN_DEPENDENCY gv_doc_writer.py
    DEPENDS gv.i
    COMMENT "generate man pages for language bindings"

=== debian/changelog ===
graphviz (14.1.2-1ubuntu1) resolute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Work around new build depends libdevil-dev and qt6-base-dev not
      being available for i386 in Ubuntu.
      - d/control:
        + Exclude libdevil-dev and qt6-base-dev bds on i386.
        * Build depend on dh-exec to allow install files to specify
          architectures.
        + Do not ship the new libgvplugin-devil8 and libgvplugin-devil-dev
          packages on i386 since their files are not built.
      - d/rules: Do not pass --with-qt to configure on i386.
      - d/graphviz-tools.install: Make executable and use dh_exex to exclude
        files not built on i386.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 31 Jan 2026 19:34:20 +0100

graphviz (14.1.2-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 29 Jan 2026 17:59:23 +0100

graphviz (14.1.1-2ubuntu2) resolute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Work around new build depends libdevil-dev and qt6-base-dev not
      being available for i386 in Ubuntu.
      - d/control:
        + Exclude libdevil-dev and qt6-base-dev bds on i386.
        * Build depend on dh-exec to allow install files to specify
          architectures.
        + Do not ship the new libgvplugin-devil8 and libgvplugin-devil-dev
          packages on i386 since their files are not built.
      - d/rules: Do not pass --with-qt to configure on i386.
      - d/graphviz-tools.install: Make executable and use dh_exex to exclude
        files not built on i386.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 06 Jan 2026 10:06:36 +0100

graphviz (14.1.1-1ubuntu1) resolute; urgency=medium

  * Work around new build depends libdevil-dev and qt6-base-dev not
    being available for i386 in Ubuntu.
    - d/control:
      + Exclude libdevil-dev and qt6-base-dev bds on i386.
      * Build depend on dh-exec to allow install files to specify
        architectures. 
      + Do not ship the new libgvplugin-devil8 and libgvplugin-devil-dev
        packages on i386 since their files are not built.
    - d/rules: Do not pass --with-qt to configure on i386.
    - d/graphviz-tools.install: Make executable and use dh_exex to exclude
      files not built on i386.

 -- Rik Mills <rikmills@kde.org>  Tue, 16 Dec 2025 11:23:08 +0000

=== debian/control ===
Source: graphviz
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Standards-Version: 4.7.2
Build-Depends: tk-dev,
 tcl-dev,
 debhelper-compat (= 13),
 dh-exec,
 dh-python,
 libfreetype-dev,
 zlib1g-dev,
 libjpeg-dev,
 libpng-dev,
 libxaw7-dev,
 bison,
 flex,
 libexpat1-dev,
 libfontconfig-dev,
 swig,
 libperl-dev,
 libgd-dev,
 guile-3.0-dev,
 groff-base,
 ghostscript,
 lua5.4,
 liblua5.4-dev,
 ruby [!ia64],
 ruby-dev [!ia64],
 libargon2-dev,
 libsodium-dev,
 libxml2-dev,
 libpython3-dev,
 python3-dev:any,
 libcairo2-dev,
 libpango1.0-dev,
 libpoppler-glib-dev,
 chrpath,
 libgs-dev,
 libgts-dev,
 libann-dev,
 librsvg2-dev [!alpha !hppa !hurd-amd64 !hurd-i386 !ia64 !m68k !sh4],
 libwebp-dev,
 libdevil-dev [!i386],
 libglut-dev,
 doxygen,
 qt6-base-dev [!i386]
Build-Conflicts: tcl8.3, tcl8.4, tcl8.5
Homepage: https://www.graphviz.org/

Package: graphviz
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, libgvc7, libgvplugin-gd8, libgvplugin-pango8, ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Recommends: fonts-liberation
Suggests: gsfonts, graphviz-doc
Description: rich set of graph drawing tools
 Graph drawing addresses the problem of visualizing structural information
 by constructing geometric representations of abstract graphs and networks.
 Automatic generation of graph drawings has important applications in key
 technologies such as database design, software engineering, VLSI and
 network design and visual interfaces in other domains. Situations where
 these tools might be particularly useful include:
 .
   * you would like to restructure a program and first need to understand
     the relationships between its types, procedures, and source files
   * you need to find the bottlenecks in an Internet backbone - not only
     individual links, but their relationships
   * you're debugging a protocol or microarchitecture represented as a
     finite state machine and need to figure out how a certain
     error state arises
   * you would like to browse a database schema, knowledge base, or
     distributed program represented graphically
   * you would like to see an overview of a collection of linked documents
   * you would like to discover patterns and communities of interest in a
     database of telephone calls or e-mail messages
 .
 This package contains the command-line tools.

Package: graphviz-tools
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: graphviz (<< 8.1.0-1~)
Replaces: graphviz (<< 8.1.0-1~)
Description: rich set of graph drawing extra tools
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the extra command-line tools.

Package: libgraphviz-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libgvc-dev (= ${binary:Version}), libcgraph-dev (= ${binary:Version}), libcdt-dev (= ${binary:Version}), libpathplan-dev (= ${binary:Version}), ${misc:Depends}
Breaks: graphviz (<< 8.1.0-1~)
Replaces: libgraphviz3-dev, libgraphviz4-dev (<< 2.16-3)
Provides: graphviz-dev
Description: graphviz libs and headers against which to build applications
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: graphviz-doc
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Section: doc
Suggests: graphviz
Description: additional documentation for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs HTML and PDF documentation for Graphviz, as well as
 examples.

#Package: smyrna
#Architecture: any
#Multi-Arch: foreign
#Depends: ${shlibs:Depends}, ${misc:Depends}
#Recommends: fonts-liberation
#Suggests: graphviz, gsfonts, graphviz-doc
#Description: viewer for graphs in the DOT format
# It is especially designed to handle large graphs, and allows flat and
# topological fisheye views. It is assumed the input graph has position
# information associated with all nodes. Using the Graphviz convention,
# a node's position is given by its \fIpos\fP attribute consisting of 2 or 3
# floating point numbers separated by commas.
# Nodes are drawn as points and edges as line segments.
#
Package: libgv-guile
Architecture: any
Multi-Arch: same
Section: interpreters
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Guile bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the guile (3.0) bindings.

Package: libgv-lua
Architecture: any
Multi-Arch: same
Section: interpreters
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lua bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the lua bindings.

Package: libgv-perl
Architecture: any
Multi-Arch: same
Section: perl
Depends: ${perl:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Perl bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Perl bindings.

Package: python3-gv
Architecture: any
Section: python
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Breaks: libgv-python (<< 2.40.1-0~)
Replaces: libgv-python (<< 2.40.1-0~)
Description: Python3 bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Python3 bindings.

Package: libgv-ruby
Architecture: any
Multi-Arch: same
Section: ruby
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ruby bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Ruby bindings.

Package: libgv-tcl
Depends: tcl-gv, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: Tcl bindings for graphviz (transitional package)
 This is a transitional package. It can safely be removed.

Package: tcl-gv
Architecture: any
Multi-Arch: same
Section: interpreters
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libgv-tcl (<< 8.1.0-1~)
Replaces: libgv-tcl (<< 8.1.0-1~)
Description: Tcl bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Tcl (8.6) bindings.

Package: libcgraph-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcgraph8 (= ${binary:Version}), libcdt-dev (= ${binary:Version}), ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Replaces: libgraphviz-dev (<< 8.1.0-1~)
Description: rich set of graph drawing tools - cgraph library (devel)
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: libcgraph8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - cgraph library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the cgraph library.

Package: libcdt-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcdt6 (= ${binary:Version}), ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Replaces: libgraphviz-dev (<< 8.1.0-1~)
Description: rich set of graph drawing tools - cdt library (devel)
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: libcdt6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - cdt library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the cdt library.

Package: libpathplan-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libpathplan4 (= ${binary:Version}), ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Replaces: libgraphviz-dev (<< 8.1.0-1~)
Description: rich set of graph drawing tools - pathplan library (devel)
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: libpathplan4
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - pathplan library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the pathplan library.

Package: libgvc-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libgvc7 (= ${binary:Version}), ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Replaces: libgraphviz-dev (<< 8.1.0-1~)
Description: rich set of graph drawing tools - gvc library (devel)
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: libgvc7
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - gvc library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the gvc library.

#Package: libgvc6-plugins-gtk
#Architecture: any
#Multi-Arch: same
#Section: libs
#Depends: ${misc:Depends}, libgvplugin-gdk (= ${binary:Version}), libgvplugin-gtk (= ${binary:Version}), libgvplugin-rsvg (= ${binary:Version})
#Description: rich set of graph drawing tools - GTK plugins
# Graphviz is a set of graph drawing tools. See the description of the graphviz
# package for a full description.
# .
# This is an empty dependency package that pulls in the GDK and GTK plugins.
#
Package: libgvpr-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libgvpr2 (= ${binary:Version}), ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Replaces: libgraphviz-dev (<< 8.1.0-1~)
Description: rich set of graph drawing tools - gvpr library (devel)
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: libgvpr2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libgvpr1

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

AUTOGENERATED = graphviz.postinst graphviz.postrm graphviz.triggers libgvc7.postinst

ifeq ($(DEB_HOST_ARCH_OS),hurd)
CONFIGURE_LIBS    = LIBS="-Wl,--no-as-needed -Wl,-lpthread -Wl,--as-needed"
endif

ifneq (,$(filter $(DEB_HOST_ARCH), mipsel mips))
DEB_CFLAGS_MAINT_APPEND += "-fno-ipa-sra"
endif

N =

ifeq ($(DEB_HOST_ARCH),ia64)
RUBY = --disable-ruby
N += -Nlibgv-ruby
else
RUBY = --enable-ruby
endif

ifeq ($(DEB_HOST_ARCH),i386)
QT = --without-qt
else
QT = --with-qt
endif

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
PERLVER := $(shell perl -MConfig -e 'print $$Config{version}')
export PERL5LIB := /usr/lib/$(DEB_HOST_MULTIARCH)/perl/cross-config-$(PERLVER)
endif

PYTHON3_VERSIONS = $(shell py3versions -r)

override_dh_clean:
	dh_clean
	$(RM) $(patsubst %, debian/%, ${AUTOGENERATED})
	$(RM) $(CURDIR)/tclpkg/gv/*.pdf $(CURDIR)/cmd/dot/*.pdf
	$(RM) $(CURDIR)/tclpkg/gv/gv.3*
	$(RM) $(CURDIR)/configure $(CURDIR)/version.m4
	$(RM) -r $(CURDIR)/public/
	find $(CURDIR) -name Makefile.in -delete

override_dh_autoreconf:
	$(CURDIR)/autogen.sh NOCONFIG
	dh_autoreconf

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@TRIPLET@%${DEB_HOST_MULTIARCH}%g' \
			< debian/$$f.in \
			> debian/$$f ; \
	done
	dh_auto_configure -- \
	--disable-silent-rules \
	--prefix=/usr \
	--datadir=\$${prefix}/share \
	--infodir=\$${prefix}/share/info \
	--mandir=\$${prefix}/share/man \
	--enable-static \
	--without-included-ltdl \
	--with-pangocairo \
	--with-x \
	--with-gdk-pixbuf \
	--with-glut \
	--with-gnomeui \
	--without-gtk \
	--with-poppler \
	--with-gts \
	--with-ipsepcola \
	--with-libgd \
	$(QT) \
	--with-rsvg \
	--with-ann \
	--with-webp \
	--with-devil \
	--without-smyrna \
	--disable-go \
	--enable-guile \
	--enable-lua \
	--disable-php \
	$(RUBY) \
	--enable-tcl \
	--disable-java \
	--disable-ocaml \
	--disable-r \
	--disable-sharp \
	--disable-python \
	--enable-python3 \
	$(CONFIGURE_LIBS) \
	$(shell $(dpkg_buildflags) --export=configure)

override_dh_auto_build-indep:
	dh_auto_build --indep
	# still need registered layout module
	PATH=./cmd/dot/:$(PATH) $(MAKE) doxygen

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian/tmp/ -name \*.la -delete
	# move Tcl files to correct path
	install -d $(CURDIR)/debian/tmp/usr/lib/tcltk/$(DEB_HOST_MULTIARCH)/
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/graphviz/tcl \
		$(CURDIR)/debian/tmp/usr/lib/tcltk/$(DEB_HOST_MULTIARCH)/gv
	# move PDF documentation to correct path
	install -d $(CURDIR)/debian/tmp/usr/share/doc/graphviz/pdf/
	mv $(CURDIR)/debian/tmp/usr/share/doc/graphviz/*.pdf \
		$(CURDIR)/debian/tmp/usr/share/doc/graphviz/pdf/
	# correct HTML path for PDF files
	sed -i 's/\.\.\///;s/doc\//pdf\//' \
		$(CURDIR)/debian/tmp/usr/share/doc/graphviz/index.html
	# Duplicate library
#	rm $(CURDIR)/debian/tmp/usr/lib/tcl*/graphviz/libgv_tcl.so

override_dh_install-arch:
	dh_install --arch
	# NFU
	rm -rf $(CURDIR)/debian/tmp/usr/lib64/

#override_dh_auto_test:
#	dh_auto_test
#	pytest-3

override_dh_compress:
	dh_compress -X.pdf

override_dh_missing:
	dh_missing --list-missing

%:
	dh $@ --with python3 $(N)

.PHONY: override_dh_clean override_dh_autoreconf override_dh_auto_configure \
	override_dh_auto_build-indep \
	override_dh_auto_install override_dh_install-arch \
	override_dh_compress override_dh_missing
